Name:        pcre2
Version:     10.42
Release:     9
Summary:     Perl Compatible Regular Expressions
License:     BSD
URL:         http://www.pcre.org/
Source0:     https://github.com/PCRE2Project/pcre2/releases/download/%{name}-%{version}/%{name}-%{version}.tar.bz2

# Do no set RPATH if libdir is not /usr/lib
Patch6000:     backport-pcre2-10.10-Fix-multilib.patch
Patch6001:     backport-no-partial-match-if-trailing-data-is-invalid-utf-238.patch
Patch6002:     backport-Fix-an-invalid-match-of-ascii-word-classes-when-inva.patch
Patch6003:     backport-fix-wrong-test.patch
Patch6004:     sljit-sv48-sv57.patch
Patch6005:     backport-fix-a-possible-integer-overflow-in-DFA-matching-305.patch

Patch6006:     backport-Fix-oversight-in-DFA-when-changing-OP_REVERSE-also-a.patch
Patch6007:     backport-Fix-32-bit-quantifier-following-a-character-larger-t.patch
Patch6008:     backport-Fix-z-behaviour-when-matching-within-invalid-UTF.patch
Patch6009:     backport-Fix-incorrect-patch-in-c1306126.patch
Patch6010:     backport-Fix-another-oversight-in-c1306126.patch
Patch6011:     backport-Fix-X-matching-in-32-bit-mode-without-UTF-in-JIT.patch
Patch6012:     backport-Fix-bad-patch-in-05206d66.-The-interpreter-was-handl.patch
Patch6013:     backport-Fix-backref-iterators-when-PCRE2_MATCH_UNSET_BACKREF.patch
Patch6014:     backport-Fix-compile-loop-in-32-bit-mode-for-characters-above.patch
Patch6015:     backport-Fix-incorrect-matching-of-0xffffffff-to-any-characte.patch
Patch6016:     backport-Fix-accept-and-endanchored-interaction-in-JIT.patch
Patch6017:     backport-Fix-backreferences-with-unset-backref-and-non-greedy.patch
Patch6018:     backport-Sanity-checks-for-ctype-functions-342.patch
Patch6019:     backport-Fix-incorrect-class-character-matches-in-JIT.patch
Patch6020:     backport-Fixing-an-issue-using-empty-character-sets-in-jit.patch
Patch6021:     backport-pcre2grep-document-better-possible-multiline-matchin.patch
Patch6022:     backport-Remove-incorrect-optimization-in-DFA-matching-when-p.patch

BuildRequires:  autoconf libtool automake coreutils gcc make readline-devel
Obsoletes:      pcre2-utf16 pcre2-utf32 pcre2-tools
Provides:       pcre2-utf16 pcre2-utf32 pcre2-tools
Provides:       bundled(sljit)

%description
PCRE2 is a re-working of the original PCRE1 library to provide an entirely new
API. Since its initial release in 2015, there has been further development of
the code and it now differs from PCRE1 in more than just the API.
PCRE2 is written in C, and it has its own API. There are three sets of
functions, one for the 8-bit library, which processes strings of bytes, one for
the 16-bit library, which processes strings of 16-bit values, and one for the
32-bit library, which processes strings of 32-bit values. Unlike PCRE1, there
are no C++ wrappers.

The distribution does contain a set of C wrapper functions for the 8-bit
library that are based on the POSIX regular expression API (see the pcre2posix
man page). These are built into a library called libpcre2-posix. Note that this
just provides a POSIX calling interface to PCRE2; the regular expressions
themselves still follow Perl syntax and semantics. The POSIX API is restricted,
and does not give full access to all of PCRE2's facilities.

%package devel
Summary:     Development files for %{name}
Requires:    %{name} = %{version}-%{release}
Obsoletes:   pcre2-static
Provides:    pcre2-static

%description devel
%{summary}.

%package help
Summary:    Man pages for %{name}
BuildArch:  noarch

%description help
%{summary}.

%prep
%autosetup -n %{name}-%{version} -p1

autoreconf -vif

%build
%configure \
%ifarch sw_64 loongarch64
    --disable-jit \
%else
    --enable-jit \
%endif
    --enable-pcre2grep-jit \
    --disable-bsr-anycrlf \
    --disable-coverage \
    --disable-ebcdic \
    --disable-fuzz-support \
    --disable-jit-sealloc \
    --disable-never-backslash-C \
    --enable-newline-is-lf \
    --enable-pcre2-8 \
    --enable-pcre2-16 \
    --enable-pcre2-32 \
    --enable-pcre2grep-callout \
    --enable-pcre2grep-jit \
    --disable-pcre2grep-libbz2 \
    --disable-pcre2grep-libz \
    --disable-pcre2test-libedit \
    --enable-pcre2test-libreadline \
    --disable-rebuild-chartables \
    --enable-shared \
    --enable-static \
    --enable-unicode \
    --disable-valgrind \
    --disable-silent-rules

%make_build

%install
%make_install

#Unpacked files
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la

%check
make check

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%license %{_pkgdocdir}/{COPYING,LICENCE}
%exclude %{_pkgdocdir}/ChangeLog
%doc AUTHORS NEWS HACKING README
%{_libdir}/libpcre2-8.so.*
%{_libdir}/libpcre2-posix.so.*
%{_libdir}/libpcre2-16.so.*
%{_libdir}/libpcre2-32.so.*
%{_bindir}/pcre2grep
%{_bindir}/pcre2test

%files devel
%{_includedir}/*.h
%{_libdir}/*.so
%{_libdir}/*.a
%{_libdir}/pkgconfig/*
%{_bindir}/pcre2-config
%doc ./src/pcre2demo.c

%files help
%{_mandir}/man1/*
%{_mandir}/man3/*
%{_pkgdocdir}/*.txt
%{_pkgdocdir}/html/

%changelog
* Tue Sep 03 2024 dongyuzhen <dongyuzhen@h-partners.com> - 10.42-9
- DESC:Remove incorrect optimization in DFA matching when partial matching and (*F) are involved

* Tue Jul 23 2024 fuanan <fuanan3@h-partners.com> - 10.42-8
- DESC:document better possible multiline matching misses

* Tue May 07 2024 xujing <xujing125@huawei.com> - 10.42-7
- DESC:Fixing an issue using empty character sets in jit

* Wed Mar 06 2024 xujing <xujing125@huawei.com> - 10.42-6
- DESC:exclude ChangeLog to avoid x86_64 conflict with i686

* Mon Jan 22 2024 xujing <xujing125@huawei.com> - 10.42-5
- DESC:Sanity checks for ctype functions
       Fix incorrect class character matches in JIT

* Mon Jan 22 2024 xujing <xujing125@huawei.com> - 10.42-4
- DESC:sync patches from upstream to fix some bugs

* Thu Dec 14 2023 xujing <xujing125@huawei.com> - 10.42-3
- DESC:fix a possible integer overflow in DFA matching (#305)

* Mon Dec 04 2023 Jingwiw  <wangjingwei@iscas.ac.cn> - 10.42-2
- enable riscv jit and fix error for sv48-sv57

* Tue Jul 18 2023 zhangchenglin <zhangchenglin@kylinos.cn> - 10.42-1
- upgrade to 10.42-1

* Mon Jun 26 2023 yangmingtai <yangmingtai@huawei.com> - 10.40-4
- DESC:sync community patches

* Thu Mar 16 2023 yangmingtai <yangmingtai@huawei.com> - 10.40-3
- DESC:sync community patches

* Sat Nov 26 2022 huyubiao <huyubiao@huawei.com> - 10.40-2
- Update the Source0 URL.

* Fri Nov 18 2022 dillon chen <dillon.chen@gmail.com> - 10.40-1
- update to 10.40

* Mon Nov 14 2022 zhaozhen <zhaozhen@loongson.cn> - 10.39-5
- Type:enhancement
- ID:NA
- SUG:NA
- DESC:fix build error for loongarch64

* Thu Nov 3 2022 wuzx<wuzx1226@qq.com> - 10.39-4
- Add sw64 architecture

* Tue Oct 18 2022 yangmingtai <yangmingtai@huawei.com> - 10.39-3
- DESC:sync community patchs

* Sat May 28 2022 yangmingtai <yangmingtai@huawei.com> - 10.39-2
- DESC:fix CVE-2022-1586 and CVE-2022-1587

* Tue Feb 8 2022 yangzhuangzhuang <yangzhuangzhuang1@h-partners.com> - 10.39-1
- Type:requirement
- ID:NA
- SUG:NA
- DESC:update to 10.39

* Thu Jan 21 2021 yixiangzhike <zhangxingliang3@huawei.com> - 10.36-1
- Type:requirement
- ID:NA
- SUG:NA
- DESC:update to 10.36

* Fri Jul 24 2020 zhangxingliang <zhangxingliang3@huawei.com> - 10.35-1
- Type:update
- ID:NA
- SUG:NA
- DESC:update to 10.35

* Tue Jun 2 2020 whoisxxx <zhangxuzhou4@huawei.com> - 10.33-4
- DESC: Disable jit for RISC-V

* Tue Apr 7 2020 openEuler Buildteam <buildteam@openeuler.org> - 10.33-3
- Type:cves
- ID:CVE-2019-20454
- SUG:NA
- DESC:fix CVE-2019-20454

* Mon Feb 3 2020 openEuler Buildteam <buildteam@openeuler.org> - 10.33-2
- Fix stack buffer overflow

* Sat Sep 14 2019 openEuler Buildteam <buildteam@openeuler.org> - 10.33-1
- Package init
